<?php
include "fefunctions.php";
include "iocommand.php";
start_session();

   /***********************************************************************
   *    Copyright � 2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/

$_SESSION["testPage"] = "";
$_SESSION["statusxml"] = "";
$_SESSION["promptID"] = "";
$_SESSION["statusDrawn"] = "false";
unset($_SESSION["completedTests"]);
$_SESSION["prompting"] = false;
$_SESSION["REFRESH_RATE"] = 2;
?>
<html>
<head>
  <meta http-equiv='content-type' content='text/html; charset=UTF-8'>
  <title>HP Insight Diagnostics</title>
  <link rel='stylesheet' type='text/css' href='stylesheets/main.css'>
  <link rel='stylesheet' type='text/css' href='stylesheets/menu.css'>
  <style> body { background: cccccc; } </style>
<SCRIPT LANGUAGE='JavaScript' SRC='menufunctions.js'></script>
<script language="JavaScript">
function InitFrameset()
{
   document.frames.dataFrame1.doTab(4);
}
</script>
</head>

<?php

  $manualOverride = $_REQUEST["man"];
  $idXml = new DomDocument($_SESSION["idResult"]);
  $root = $idXml->document_element();
  if (!$root->has_child_nodes())
  {
    $resultCommand = sprintf("<getProcessResult processID='%s' />", $_REQUEST["pid"]);
    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $resultCommand, $_SESSION["idResult"], $idErrors);
    $_SESSION["idXml"] = new DomDocument($_SESSION["idResult"]);
    
    printf("<script language='Javascript'>\nwindow.location='hpdiags.php?pid=%s';\n</script>\n", $_REQUEST["pid"]);
  }
  else
  {
    
    $filepath = $_SESSION["diagsDirectory"] . "diagconfig.xml";
    if (!$dom = LoadXmlDocument($filepath))
    {
      echo "NO DIAG CONFIG";
      exit;
    }

	  $rootXpath = xpath_new_context($dom->document_element());
	  $srcs = xpath_eval($rootXpath, "/src");
    
    $idXpath = @xpath_new_context($root);
    $runMeNowTests = @xpath_eval($idXpath, "/diagOutput/category/device/test[@runMeNow='1']");    
    
    if (count($runMeNowTests->nodeset))
    {
      $dom = domxml_new_doc("1.0");
      $startProcess = $dom->create_element("startProcess");
      $diagRun = $dom->create_element("diagRun");
      $diagRun->set_attribute("language", GetLanguage());        
      
      $num_runMeNowTests = count($runMeNowTests->nodeset);
      for ($i=0; $i < $num_runMeNowTests; $i++)
      {
        // build the runTest object
	      $testNode = $runMeNowTests->nodeset[$i];
	      $testParent = $testNode->parent_node();
        $testName = $testNode->get_attribute("name");
	      $testDescription = $testNode->get_attribute("description");
	      $testCaption = $testNode->get_attribute("caption");
	      $deviceCaption = $testParent->get_attribute("caption");
        $cdmClass = $testParent->get_attribute("cdmClass");              
        $componentName = $testParent->get_attribute("component");
        $deviceSlot = $testParent->get_attribute("Slot");
        if ($componentName == "cdm")
          $deviceName = $testParent->get_attribute("deviceID");
        else
	        $deviceName = $testParent->get_attribute("name");              

	      $runTest = $dom->create_element("runTest");
	      $runTest->set_attribute("component", $componentName);
      
        if ($componentName == "cdm")
        {
          $runTest->set_attribute("cdmClass", $cdmClass);
        }
      
	      $tcLoadFilename = $componentName . ".dat";
	      $runTest->set_attribute("tcLoadFilename", $tcLoadFilename);
	      $runTest->set_attribute("language", GetLanguage());
      
        $runTest->set_attribute("device", $deviceName);
        $runTest->set_attribute("test", $testName);
        if ($deviceSlot != "")
          $runTest->set_attribute("Slot", $deviceSlot); // slot the ctrlr is in that the device is attached to
        $runTest->set_attribute("description", htmlentities($testDescription,ENT_QUOTES,'utf-8'));
	      $runTest->set_attribute("caption", htmlentities($deviceCaption . " - " . $testCaption,ENT_QUOTES,'utf-8'));
        if ($testNode->get_attribute("singleThread") == "1")
          $runTest->set_attribute("singleThread", "1");
        if ($testNode->get_attribute("interactive") == "1" && $_SESSION["testMode"] == "interactive")
          $runTest->set_attribute("interactive", "1");

        $diagRun->append_child($runTest);
      }
      
      $startProcess->append_child($diagRun);
      $dom->append_child($startProcess);    
      //echo htmlentities($dom->html_dump_mem());
      SubmitDiagRun($dom);
          
    }    
	  else if (count($srcs->nodeset) && !$manualOverride)
	  {// found a reference to a script file
	    $srcfile = $srcs->nodeset[0]->get_attribute("name");
	    $srcpath = $srcs->nodeset[0]->get_attribute("path");

	    if ($srcpath == "")
	      $srcpath = $_SESSION["diagsDirectory"];

      // if they want to create and use a factory.xml file
      if (strstr($srcfile,"factory.xml"))
	    {
        $contents = getDirectoryContents($srcpath); // get all the files from the directory
        
        $dir_length = count($contents);
        for($i=0;$i<$dir_length;$i++)
        {
          if (strstr($contents[$i], ".src.xml")) // found the script file
          {
            if (!file_exists($srcpath . "factory.xml"))
            {
              // now translate the script file from DxEdit xml schema to Diags xml schema
		          $dxtransErrors = "";
  	          $dxtransStatus = "";
  	          $dxtransStr = sprintf("<systemCall>%sdxtranslate %s%s</systemCall>", $_SESSION["diagsDirectory"], $_SESSION["diagsDirectory"], $contents[$i]);
  	          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $dxtransStr, $dxtransStatus, $dxtransErrors);
            }
            // open the factory.xml file
            if ($xmldoc = @LoadXmlDocument($srcpath . $srcfile))
            {
              $factoryRoot = $xmldoc->document_element();
              $factoryXML = @xpath_new_context($factoryRoot);
              $station = $factoryRoot->get_attribute("station");
              // find out what script needs to be run first
              $srcs = @xpath_eval($factoryXML, "/src[@station='$station']");
              if (count($srcs->nodeset))
              {
                $status = $srcs->nodeset[0]->get_attribute("status");
                if (strstr($status, "assed")) // if Passed or passed
                {
                  $station++;
                  $srcs = @xpath_eval($factoryXML, "/src[@station='$station']");
                  if (count($srcs->nodeset))
                    $scriptFile = $srcs->nodeset[0]->get_attribute("name"); // get the script's filename
                  $factoryRoot->set_attribute("station", $station);
                  $result = FactorySaveFile("factory.xml", "harddrive", $xmldoc->dump_mem());
                }
                else
                  $scriptFile = $srcs->nodeset[0]->get_attribute("name"); // get the script's filename
                $scriptFile = $_SESSION["diagsDirectory"] . $scriptFile;
              }
            }
            break;
          }
        }
        
	    }
      else
        $scriptFile = $srcpath . $srcfile;

      $errorsFound = false;
      // check errorlog for errors - do not run if so
      if ($errorLog = @LoadXmlDocument($_SESSION["diagsDirectory"] . "errorlog.xml"))
      {
        $errorLogRoot = @xpath_new_context($errorLog->document_element());
        $errorLogRecords = @xpath_eval($errorLogRoot, "/errorLogRecord");
        if (count($errorLogRecords->nodeset) > 0 && !checkDiagconfig("/factory/ignoreErrorLog")) // found Errors
        {
          $errorsFound = true;
  	      // GO TO ERROR LOG PAGE NOW...
          printf("<frameset  rows='0,0,65,40,50,*' framespacing=0 frameborder=0 border=0 onload=\"InitFrameset()\" ");
          if (IsOnline())
           printf("onunload=\"window.open('exit.php');\"");
          printf(">\n");
          printf("  <frame name='globalFrame' src='globals.php?tabpage=logtabs' noresize marginwidth=0 marginheight=0 scrolling=auto>\n");
          printf("  <frame name='invisibleFrame' src='' noresize marginwidth=0 marginheight=0 scrolling=auto>\n");
          printf("  <frame name='headerFrame' src='header.php' marginWidth=0 marginHeight=0 scrolling='no'>\n");
          printf("	<frame name='dataFrame1' src='' marginWidth=10 marginHeight=10 scrolling='no'>\n");
          printf("	<frame name='dataFrame2' src='' marginWidth=10 marginHeight=10 scrolling='no'>\n");
          printf("	<frame name='dataFrame3' src='' marginWidth=10 marginHeight=10 scrolling='auto'>\n");
          printf("</frameset>\n");
        }

      }

	    if (($scriptXmldoc = @LoadXmlDocument($scriptFile)) && !$errorsFound)
		  {

        $scriptRoot = xpath_new_context($scriptXmldoc->document_element());
        $runTests = @xpath_eval($scriptRoot, "/diagRun/runTest");
        if (count($runTests->nodeset))
        {

          // get test caption from idresult then add it to the script
          $num_runTests = count($runTests->nodeset);
          
          for ($i=0; $i < $num_runTests; $i++)
          {  
            $runTest = $runTests->nodeset[$i];
            $device = $runTest->get_attribute("device");
            $test = $runTest->get_attribute("test");
            $idXpath = xpath_new_context($idXml->document_element());
            $deviceObjs = @xpath_eval($idXpath, "/diagOutput/category/device[@name='".$device."']");
            if (count($deviceObjs->nodeset))
            {
              $deviceObj = $deviceObjs->nodeset[0];
              $deviceCaption = $deviceObj->get_attribute("caption");
              $deviceXpath = xpath_new_context($deviceObj);
              $testObjs = xpath_eval($deviceXpath, "/test[@name='".$test."']");

              if (count($testObjs->nodeset))
              {
                $testCaption = $testObjs->nodeset[0]->get_attribute("caption");
                $runTest->set_attribute("caption", $deviceCaption." - ".$testCaption);
              }
            }  
          }          

          // Submit the diagRun command - script file
          SubmitDiagRun($scriptXmldoc);
        }                              
        else
        {
         
 
  	      printf("<script language=\"JavaScript\">\n");
          printf("alert('%s');\n", TR("MSG_NO_TESTS_DEFINED_IN_SCRIPT_FILE"));
  	      printf("</script>\n");          
        }

		  }
      else
      { 
  	    printf("<script language=\"JavaScript\">\n");
        printf("alert('Could not open script file - Please verify diagconfig.xml');\n");
  	    printf("</script>\n");          
      }
		  	    
	  }
    else
    {
  
      printf("<frameset  rows='0,0,65,");
      $ci = new client_info();
      if ((strstr($ci->get_client_browser(), "ozilla") || strstr($ci->get_client_browser(), "etscape")) && IsOnline() && !strstr($ci->get_client_platform(), "indows"))
        printf("37");
      else
        printf("40");
      printf(",50,*' framespacing=0 frameborder=0 border=0 ");
      if (IsOnline())
       printf("onunload=\"window.open('exit.php');\"");
      printf(">\n");
      printf("  <frame name='globalFrame' src='globals.php?tabpage=surveytabs' noresize marginwidth=0 marginheight=0 scrolling=auto>\n");
      printf("  <frame name='invisibleFrame' src='' noresize marginwidth=0 marginheight=0 scrolling=auto>\n");
      printf("  <frame name='headerFrame' src='header.php' marginWidth=0 marginHeight=0 scrolling='no'>\n");
      printf("	<frame name='dataFrame1' src='' marginWidth=10 marginHeight=10 scrolling='no'>\n"); //tabs.php?category=overview
      printf("	<frame name='dataFrame2' src='' marginWidth=10 marginHeight=10 scrolling='no'>\n"); //surveytabs.php?category=overview
      printf("	<frame name='dataFrame3' src='' marginWidth=10 marginHeight=10 scrolling='auto'>\n");
      printf("</frameset>\n");
    }
  }
  
  function SubmitDiagRun($diagRunXml)
  {
		      $runErrors = "";
  	      $runStatus = "";
          if (GetLanguage() == "ja")
            $diagRunStr = sprintf("%s", $diagRunXml->dump_mem(true, "UTF-8"));
          else
            $diagRunStr = sprintf("%s", $diagRunXml->dump_mem());
  	      $_SESSION["diagRun"] = $diagRunStr;
  	      ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $diagRunStr, $runStatus, $runErrors);
  	      $_SESSION["scriptTesting"] = true;
          $xmldoc = new DomDocument($runStatus);
            
  	      $_SESSION["statusxml"] = "";
  
		      $rootElement = $xmldoc->document_element();
  	      $_SESSION["testpid"] = $rootElement->get_attribute("processID");
          $_SESSION["testPage"] = "custom.php";

  	      // GO TO STATUS PAGE NOW...
          if (IsFactory())
            printf("<frameset  rows='0,0,65,40,50,*' framespacing=0 frameborder=0 border=0 onload=\"document.frames.globalFrame.tabpage='statusheader.php';document.frames.dataFrame1.doTab(3);\" ");
          else
            printf("<frameset  rows='0,0,65,40,50,*' framespacing=0 frameborder=0 border=0 ");
          if (IsOnline())
           printf("onunload=\"window.open('exit.php');\"");
          printf(">\n");
          printf("  <frame name='globalFrame' src='globals.php?tabpage=statusheader' noresize marginwidth=0 marginheight=0 scrolling=auto>\n");
          printf("  <frame name='invisibleFrame' src='' noresize marginwidth=0 marginheight=0 scrolling=auto>\n");
          printf("  <frame name='headerFrame' src='header.php' marginWidth=0 marginHeight=0 scrolling='no'>\n");
          printf("	<frame name='dataFrame1' src='' marginWidth=10 marginHeight=10 scrolling='no'>\n");
          if (IsFactory())
            printf("	<frame name='dataFrame2' src='' marginWidth=10 marginHeight=10 scrolling='no'>\n");
          else
            printf("	<frame name='dataFrame2' src='statusheader.php' marginWidth=10 marginHeight=10 scrolling='no'>\n");
          printf("	<frame name='dataFrame3' src='' marginWidth=10 marginHeight=10 scrolling='auto'>\n");
          printf("</frameset>\n");
  
  }

?>
